#ifndef BCURV_H
#   define BCURV_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>

typedef enum { STRAIGHT_LINE_SEGMENT = 0, CIRCULAR_ARC = 1 } b_curve_type_enum;

typedef void *b_curve_t;


b_curve_t 
bcurv_make_line(double fx, double fy, double lx, double ly);

b_curve_t 
bcurv_make_circ_arc(double fx, double fy, /* first point */
                    double lx, double ly, /* last point */
                    int intermed_p_is_valid, /* Is the following valid? */
                    double ix, double iy, /* intermediate point */
                    double cx, double cy, /* center */
                    int opposite_dir /* Default orientation is ccw; */
                                     /* if this parameter is set, the */
                                     /* orientation is cw */
                    );

double 
bcurv_find_close_eta(b_curve_t curve, double x, double y,
                     double eta_lower, double eta_upper);

void
bcurv_interpolate(double param,
                  b_curve_t curve,
                  double *x, double *y);



#endif /* BCURV_H */
