#include "hexmesh.h"
#include "tfmap.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define VECMAC_VECTOR_TYPE 1
#include "vecmacP.h" 
#define WANT_VECTP_ALIASES
#include "vectP.h" /* to be able to use vector library routines. */





/* 
c89 -D_HPUX_SOURCE hemigen.c -I../include -I../../Ckit/include -I../../Elixir/include ../src/integ2.o -I../../Meschach -L../../Meschach -L../../Ckit/src ../../Meschach/meschach.a -lckit -lm
 */

/* Modify this */

#define vect CkitPoint3
static vect p0 = {0.7071070, 0.0000000, 0.7071070};
static vect p1 = {1.0000000, 0.0000000, 0.0000000};
static vect p2 = {0.7071070, 0.7071070, 0.0000000};
static vect p3 = {0.5773500, 0.5773500, 0.5773500};



#define One 1.0001


static void
q4_N(double ksi, double eta, double n[4])
{
  double one_minus_ksi = (1 - ksi);
  double one_plus_ksi  = (1 + ksi);
  double one_minus_eta = (1 - eta);
  double one_plus_eta  = (1 + eta);
  
  n[0] = 0.25 * one_minus_ksi * one_minus_eta;
  n[1] = 0.25 * one_plus_ksi  * one_minus_eta;
  n[2] = 0.25 * one_plus_ksi  * one_plus_eta;
  n[3] = 0.25 * one_minus_ksi * one_plus_eta;
}


int
generate_sphere_octant(int nv_per_side, double radius)
{
  double ksi, eta, N[4];
  double norm;
  vect v;
  int nv, np, nr, nc, i, j, n1, n2, n3, n4, ix;
  vect vs[10000]; /* ugly hack */
  double STEP = 2.0 / (double)(nv_per_side - 1);

  nr = nc = nv_per_side - 1;
  nv = (nr + 1) * (nc + 1);
  np = nr * nc;;

  ix = 0;
  for (ksi = -1; ksi < One; ksi += STEP) {
    for (eta = -1; eta < One; eta += STEP) {
      q4_N(ksi, eta, N);
      v.x = N[0] * p0.x + N[1] * p1.x + N[2] * p2.x + N[3] * p3.x;
      v.y = N[0] * p0.y + N[1] * p1.y + N[2] * p2.y + N[3] * p3.y;
      v.z = N[0] * p0.z + N[1] * p1.z + N[2] * p2.z + N[3] * p3.z;
      norm = VECMAC_NORM (v);
      VECMAC_SCALAR (v, *=, radius / norm);
      vs[ix++] = v;
    }
  }
      
  for (i = 0; i < nr; i++)
    for (j = 0; j < nc; j++) {
      vect pts[4];
      GraphicObj *q = 0;
      n1 = i * (nc+1) + j + 1;
      n2 = n1 + 1;
      n4 = n1 + (nc+1);
      n3 = n4 + 1;
      pts[0] = vs[n1-1];
      pts[1] = vs[n2-1];
      pts[2] = vs[n3-1];
      pts[3] = vs[n4-1];
      q = CreateQuad3D(pts);						\
      EGWithMaskChangeAttributes(ALL_ATTRIB_MASK, q);                 \
      EMNoDrawAddGraphicsToModel(ESIModel(), q);			\
    }
  
  return 1;
}



