#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define VECMAC_VECTOR_TYPE 1
#include "vecmacP.h" 
#define WANT_VECTP_ALIASES
#include "vectP.h" /* to be able to use vector library routines. */





/* 
c89 -D_HPUX_SOURCE hemigen.c -I../include -I../../Ckit/include -I../../Elixir/include ../src/integ2.o -I../../Meschach -L../../Meschach -L../../Ckit/src ../../Meschach/meschach.a -lckit -lm
 */

/* Modify this */
#define RADIUS      1.0


#define vect CkitPoint3
static vect p0 = {0.7071070, 0.0000000, 0.7071070};
static vect p1 = {1.0000000, 0.0000000, 0.0000000};
static vect p2 = {0.7071070, 0.7071070, 0.0000000};
static vect p3 = {0.5773500, 0.5773500, 0.5773500};



#define One 1.001


static void
q4_N(double ksi, double eta, double n[4]);


int
main(int argn, char **argv)
{
  double ksi, eta, N[4];
  double norm;
  vect v;
  int nv, np, nr, nc, i, j, n1, n2, n3, n4;
  int NV_PER_SIDE=  3;

  if (argn == 2) {
    NV_PER_SIDE = atoi(argv[1]);
  }
  {
    double STEP = 2.0 / (double)(NV_PER_SIDE - 1);
    nr = nc = NV_PER_SIDE - 1;
    nv = (nr + 1) * (nc + 1);
    np = nr * nc;;
    
    printf("%d %d\n", nv, np);
    
    for (ksi = -1; ksi < One; ksi += STEP) {
      for (eta = -1; eta < One; eta += STEP) {
        q4_N(ksi, eta, N);
        v.x = N[0] * p0.x + N[1] * p1.x + N[2] * p2.x + N[3] * p3.x;
        v.y = N[0] * p0.y + N[1] * p1.y + N[2] * p2.y + N[3] * p3.y;
        v.z = N[0] * p0.z + N[1] * p1.z + N[2] * p2.z + N[3] * p3.z;
        norm = VECMAC_NORM (v);
        VECMAC_SCALAR (v, *=, RADIUS / norm);
        printf("%g %g %g\n", v.x, v.y, v.z);
      }
    }
    
    for (i = 0; i < nr; i++)
      for (j = 0; j < nc; j++) {
        n1 = i * (nc+1) + j + 1;
        n2 = n1 + 1;
        n4 = n1 + (nc+1);
        n3 = n4 + 1;
        printf("4\t\t%d \t%d \t%d \t%d\n", n1, n2, n3, n4);
      }
    
    return 0;
  }
}


static void
q4_N(double ksi, double eta, double n[4])
{
  double one_minus_ksi = (1 - ksi);
  double one_plus_ksi  = (1 + ksi);
  double one_minus_eta = (1 - eta);
  double one_plus_eta  = (1 + eta);
  
  n[0] = 0.25 * one_minus_ksi * one_minus_eta;
  n[1] = 0.25 * one_plus_ksi  * one_minus_eta;
  n[2] = 0.25 * one_plus_ksi  * one_plus_eta;
  n[3] = 0.25 * one_minus_ksi * one_plus_eta;
}
